;Resident Extended Keyboard
;(c) 1989 Martin Mares, MJSoft

udg	equ	23675
bordcr	equ	23624
lastk	equ	23560
eline	equ	23641

	org	23755
	call	0d6bh
	ld	a,254
	call	1601h
	ld	de,msg1
	ld	bc,msg2-msg1
	call	203ch
	ld	bc,tab
	call	2d2bh
	call	2de3h
	ld	a,13
	rst	16
	di
	ld	a,(urep)
	or	a
	jr	nz,noudg
	ld	hl,(udg)
	ld	de,65280
	and	a
	sbc	hl,de
	ld	a,h
	or	l
	jr	nz,noudg
	ex	de,hl
	ld	de,ubuf
	push	de
	ld	bc,168
	ldir
	pop	hl
	ld	(udg),hl
	ld	a,1
	ld	(urep),a
noudg	ld	a,39h
	ld	i,a
	ld	a,18h
	ld	(65535),a
	ld	hl,0fff4h
	ld	(hl),0c3h
	inc	hl
	ld	de,irout
	ld	(hl),e
	inc	hl
	ld	(hl),d
	im	2
	ei
	ret

irout	push	af
	ld	a,(action)
	or	a
	jp	nz,send
	ld	a,7fh
	in	a,(0feh)
	bit	1,a
	jr	nz,irnor
	rrca
	jr	nc,defkey
	ld	a,0bfh
	in	a,(0feh)
	rrca
	jr	nc,exekey
irnor	pop	af
	jp	56

exekey	call	releas
	push	bc
	push	de
	push	hl
	call	keyin
	call	find
	jr	nc,error
exesen	inc	hl
	ld	(sendad),hl
	ld	a,1
	ld	(action),a
	jr	exeend
error	ld	hl,200
	call	borcol
	ld	c,a
err1	ld	a,c
	out	(254),a
	xor	16
	ld	c,a
	ld	b,128
err2	djnz	err2
	dec	hl
	ld	a,h
	or	l
	jr	nz,err1
exeend	pop	hl
	pop	de
	pop	bc
	call	borcol
	out	(254),a
intend	pop	af
	ei
	ret

defkey	push	bc
	push	de
	push	hl
	call	releas
	call	keyin
	sub	41h
	jr	c,error
	cp	4
	jr	nc,error
	rrca
	ld	(opts),a
	call	c,clear
	call	keyin
	ld	(sendad),a
	call	find
	jr	c,error
	ld	hl,(eline)
	push	hl
	ld	bc,0
dffind	ld	a,(hl)
	cp	13
	jr	z,dfchk
	inc	bc
	inc	hl
	jr	dffind
dfchk	pop	de
	ld	a,b
	or	c
	jr	z,error
	push	bc
	inc	bc
	ld	hl,(last)
	push	hl
	add	hl,bc
	ld	bc,tend
	and	a
	sbc	hl,bc
	pop	hl
	pop	bc
	jr	nc,error
	ld	a,(sendad)
	ld	(hl),a
	inc	hl
	ex	de,hl
	ldir
	ex	de,hl
	ld	a,(opts)
	rrca
	jr	nc,nocr
	ld	(hl),13
	inc	hl
nocr	ld	(hl),0
	inc	hl
	ld	(hl),1
	ld	(last),hl
	call	16b0h
	ld	a,13
	ld	(23560),a
	set	5,(iy+1)
	jr	exeend

send	bit	5,(iy+1)
	jr	nz,intend
	push	hl
	ld	hl,(sendad)
	ld	a,(hl)
	or	a
	jr	nz,send1
	xor	a
	ld	(action),a
	jr	seend
send1	ld	a,(hl)
	inc	hl
	ld	(sendad),hl
	ld	(lastk),a
	set	5,(iy+1)
seend	pop	hl
	jp	intend

keyin	call	028eh
	ld	a,e
	inc	a
	jr	z,keyin
	ld	d,0
	ld	hl,0205h
	add	hl,de
	ld	a,(hl)
	cp	32
	jr	c,keyin
	push	af
keyrel	call	028eh
	ld	a,e
	inc	a
	jr	nz,keyrel
	pop	af
	ret

releas	call	borcol
	inc	a
	and	7
	jr	nz,rebor
	ld	a,6
rebor	out	(254),a
reloop	ld	a,7fh
	in	a,(0feh)
	bit	1,a
	jr	z,reloop
	rrca
	jr	nc,reloop
	ld	a,0bfh
	in	a,(0feh)
	rrca
	jr	nc,reloop
	ret

borcol	ld	a,(bordcr)
	rrca
	rrca
	rrca
	and	7
	ret

find	ld	c,a
	ld	hl,tab
exefin	ld	a,(hl)
	cp	1
	ret	z
	cp	c
	scf
	ret	z
exskip	ld	a,(hl)
	inc	hl
	or	a
	jr	nz,exskip
	jr	exefin

clear	ld	hl,tab
	ld	(hl),1
	ld	(last),hl
	ret

urep	nop
ubuf	defs	168
action	nop
sendad	defs	2
tab	defb	1
	defs	2047
tend
last	defw	tab
msg1	defm	'MJSoft '
	defm	'Resident ExtKey'
	defb	13
	defm	'(c) 1989 Martin '
	defm	'Mares'
	defb	13,13
	defm	'Table adress:'
msg2
opts	nop
