;Powers of 2 - version 2.0
;(c) 1990 MJSoft System Software
;Martin Mares

size	equ	1000
code	equ	60000
buf	equ	code-size
number	equ	buf-2
limit	equ	number-2
over	equ	limit-1

	org	code

	jp	calc
	jp	dump

calc	call	init
loop	ld	a,(number)
	and	31
	jp	nz,loop1
	ld	a,7
	out	(254),a
	xor	a
	out	(254),a
	ld	a,(number)
	and	255
	jp	nz,loop1
	ld	a,(number+1)
	and	1
	jp	nz,loop1
	ld	a,'*'
	rst	16
loop1	call	comp
	or	a
	jr	z,loop
dump	call	0d6bh
	ld	a,254
	call	1601h
	jp	disp

init	ld	hl,buf
	ld	bc,size-1
ini1	ld	(hl),0
	inc	hl
	dec	bc
	ld	a,b
	or	c
	jr	nz,ini1
	ld	(hl),1
	ld	hl,0
	ld	(number),hl
	ld	l,1
	ld	(limit),hl
	ld	a,h
	ld	(over),a
	ld	a,254
	jp	1601h

disp	ld	bc,(number)
	call	2d2bh
	call	2de3h
	ld	a,32
	rst	16
	ld	a,(over)
	or	a
	jr	z,dis0
	ld	a,'1'
	rst	16
dis0	ld	hl,buf+size
	ld	bc,(limit)
	and	a
	sbc	hl,bc
dis1	ld	a,(hl)
	inc	hl
	add	a,'0'
	rst	16
	dec	bc
	ld	a,b
	or	c
	jr	nz,dis1
	ld	a,13
	rst	16
	ret

comp	ld	hl,(number)
	inc	hl
	ld	(number),hl
	ld	hl,buf+size-1
	ld	bc,(limit)
	ld	d,0
com1	ld	a,(hl)
	add	a,a
	add	a,d
	ld	d,0
com2	cp	10
	jp	c,com3
	sub	10
	inc	d
	jp	com2
com3	ld	(hl),a
	dec	hl
	dec	bc
	ld	a,b
	or	c
	jp	nz,com1
	ld	a,d
	or	a
	ret	z
	ld	(hl),a
	ld	hl,(limit)
	inc	hl
	ld	(limit),hl
	ld	de,size
	xor	a
	sbc	hl,de
	ret	c
	add	hl,de
	dec	hl
	ld	(limit),hl
	inc	a
	ld	(over),a
	ret
