	ORG	60000
	JP	TEXT
	LD	SP,(23613)
	DEC	SP
	DEC	SP
	LD	A,(RAM)
	OR	A
	CALL	Z,COR
	CALL	COMP
	JP	PRINT
FONT	EQU	17104
CHRAD	LD	L,A
	LD	H,0
	ADD	HL,HL
	ADD	HL,HL
	LD	B,H
	LD	C,L
	ADD	HL,BC
	ADD	HL,BC
	LD	B,H
	LD	C,L
	ADD	HL,BC
	ADD	HL,BC
	ADD	HL,BC
	ADD	HL,BC
	LD	BC,FONT
	ADD	HL,BC
	RET
PRINT	LD	HL,(VARS)
	PUSH	HL
	CALL	PINIT
	LD	IX,VARS
	LD	A,(IX+2)
	OR	A
	JR	Z,PO2
	LD	B,A
PX1	CALL	CRLF
	DJNZ	PX1
PO2	CALL	CLBUF
	EXX
	LD	C,0
	EXX
PRTHI	EXX
	LD	D,128
	EXX
PRLIN	EXX
	LD	B,(IX+6)
	EXX
PRYMG	EXX
	LD	HL,BUF
	EXX
PRCHR	EXX
	LD	A,(HL)
	INC	HL
	EXX
	CP	13
	JR	Z,PREOL
	SUB	32
	CALL	CHRAD
	EXX
	LD	A,C
	EXX
	LD	C,A
	LD	B,0
	ADD	HL,BC
	LD	C,(IX+16)
PRCPT	LD	B,(IX+4)
PRXMG	EXX
	LD	A,D
	EXX
	AND	(HL)
	CALL	CONVB
	EX	DE,HL
	OR	(HL)
	LD	(HL),A
	EX	DE,HL
	INC	DE
	DJNZ	PRXMG
	LD	A,(IX+8)
	OR	A
	JR	Z,PRNXS
	LD	B,A
PRXSP	INC	DE
	DJNZ	PRXSP
PRNXS	INC	HL
	INC	HL
	INC	HL
	DEC	C
	JR	NZ,PRCPT
	LD	B,(IX+14)
	LD	A,B
	OR	A
	JR	Z,PRNCS
PRCHS	INC	DE
	DJNZ	PRCHS
PRNCS	JR	PRCHR
PREOL	LD	L,(IX)
	LD	H,(IX+1)
	LD	C,(IX+12)
	LD	A,C
	RLA
	SBC	A,A
	LD	B,A
	ADD	HL,BC
	LD	(IX),L
	LD	(IX+1),H
	CALL	NXTLIN
	EXX
	DEC	B
	EXX
	JR	NZ,PRYMG
	LD	A,(IX+10)
	OR	A
	LD	B,A
	JR	Z,PRNYS
PRYSP	PUSH	BC
	CALL	NXTLIN
	POP	BC
	DJNZ	PRYSP
PRNYS	EXX
	RRC	D
	EXX
	JP	NC,PRLIN
	EXX
	INC	C
	LD	A,C
	EXX
	CP	3
	JP	C,PRTHI
	POP	HL
	LD	(VARS),HL
	RET
NXTLIN	EXX
	INC	E
	LD	A,E
	EXX
	CP	8
	JR	C,CBEND
	PUSH	BC
	PUSH	DE
	PUSH	HL
	CALL	GMODE
	LD	HL,16384
	LD	BC,(PPL)
COPY1	LD	A,(HL)
	CALL	PPRINT
	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,COPY1
	CALL	CRLF
	POP	HL
	POP	DE
	POP	BC
CLBUF	PUSH	HL
	LD	HL,16384
	PUSH	BC
	LD	BC,(PPL)
CBUF1	LD	(HL),0
	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,CBUF1
	POP	BC
	POP	HL
	EXX
	LD	E,0
	EXX
CBEND	PUSH	HL
	LD	HL,(VARS)
	LD	DE,16384
	ADD	HL,DE
	EX	DE,HL
	POP	HL
	RET
PINIT	LD	A,(INTER)
	LD	L,A
	LD	H,0
	ADD	HL,HL
	LD	DE,INTAB
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	PUSH	DE
	RET
INTAB	DEFW	ICHNP
	DEFW	I128
ICHNP	LD	HL,CHPIN
	LD	DE,CHPPR
	LD	BC,RT
	JR	INSTPR
I128	LD	HL,RT
	LD	DE,S12PR
	LD	BC,RT
INSTPR	LD	(AREADY),BC
	LD	(APRINT),DE
	PUSH	HL
	RET
AREADY	DEFS	2
APRINT	DEFS	2
CHPIN	LD	A,3
	JP	1601H
CHPPR	RST	16
	RET
S12PR	LD	E,A
	DI
	XOR	A
	LD	BC,32765
	OUT	(C),A
	LD	A,E
	CALL	08C2H
	LD	A,16
	LD	BC,32765
	OUT	(C),A
	EI
	RET
RT	XOR	A
	RET
PPRINT	PUSH	BC
	PUSH	DE
	PUSH	HL
	PUSH	AF
	EXX
	PUSH	BC
	PUSH	DE
	PUSH	HL
	EXX
	PUSH	AF
	PUSH	IX
PPR1	CALL	PREADY
	JR	NZ,PPR1
	POP	IX
	POP	AF
	PUSH	IX
	CALL	BPRINT
	POP	IX
	EXX
	POP	HL
	POP	DE
	POP	BC
	EXX
	POP	AF
	POP	HL
	POP	DE
	POP	BC
	RET
BPRINT	LD	HL,(APRINT)
	PUSH	HL
	RET
PREADY	LD	HL,(AREADY)
	PUSH	HL
	RET
CRLF	LD	A,13
	CALL	PPRINT
	LD	A,10
	JP	PPRINT
GMODE	LD	A,27
	CALL	PPRINT
	LD	A,'A'
	CALL	PPRINT 
	LD	A,8
	CALL	PPRINT
	LD	A,27
	CALL	PPRINT
	LD	A,(DENS)
	ADD	A,'K'
	CALL	PPRINT
	LD	HL,(PPL)
	LD	A,L
	CALL	PPRINT
	LD	A,H
	JP	PPRINT
CONVB	PUSH	BC
	LD	C,A
	EXX
	LD	A,D
	EXX
COB1	RLA
	JR	C,COB2
	SLA	C
	JR	COB1
COB2	EXX
	LD	A,E
	EXX
	OR	A
	JR	Z,COB4
	LD	B,A
COB3	SRL	C
	DJNZ	COB3
COB4	LD	A,C
	POP	BC
	RET
COR	XOR	A
COR1	PUSH	AF
	PUSH	AF
	CALL	CHRAD
	POP	AF
	PUSH	HL
	LD	L,A
	LD	H,0
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	BC,3D00H
	ADD	HL,BC
	LD	DE,16384
	LD	BC,8
	LDIR
	LD	HL,16384
	LD	B,8
CORA	SLA	(HL)
	INC	HL
	DJNZ	CORA
	LD	DE,16384
	POP	HL
	PUSH	HL
	LD	B,60
CORB	LD	(HL),0
	INC	HL
	DJNZ	CORB
	POP	HL
	LD	C,6
CORC	LD	B,3
CORD	PUSH	BC
	LD	C,8
	LD	E,7
CORE	LD	B,3
CORF	LD	A,(DE)
	AND	128
	RLA
	RR	(HL)
	INC	HL
	RR	(HL)
	INC	HL
	RR	(HL)
	DEC	HL
	DEC	HL
	DJNZ	CORF
	DEC	E
	DEC	C
	JR	NZ,CORE
	INC	HL
	INC	HL
	INC	HL
	POP	BC
	DJNZ	CORD
	PUSH	HL
	LD	HL,16384
	LD	B,8
CORG	SLA	(HL)
	INC	HL
	DJNZ	CORG
	POP	HL
	DEC	C
	JR	NZ,CORC
	POP	AF
	INC	A
	CP	96
	JR	C,COR1
	RET
COMP	LD	HL,360
	LD	A,(DENS)
	OR	A
	JR	Z,COM1
	ADD	HL,HL
COM1	LD	(PPL),HL
	RST	32
	CALL	1C8CH
	CALL	2BF1H
	LD	A,B
	OR	C
	JP	Z,8
	EX	DE,HL
	LD	DE,BUF
	LDIR
	LD	A,13
	LD	(DE),A
	RET
PPL	DEFS	2
BUF	EQU	22864



TEXT	RST	32
	CALL	1C8CH
	CALL	2BF1H
	LD	IX,TVARS
	LD	(IX+13),E
	LD	(IX+14),D
	LD	(IX+15),C
	LD	(IX+16),B
	LD	A,(IX+5)
	LD	(IX+11),A
	CALL	PINIT
	CALL	DEFCH
	CALL	MODE
TCOPY	LD	A,(IX+11)
	OR	A
	JP	Z,BASIC
	DEC	(IX+11)
	LD	A,(IX+8)
	LD	(IX+12),A
	LD	A,(IX+2)
	LD	(IX+9),A
	LD	A,(IX+3)
	LD	(IX+10),A
	LD	(IX+17),1
	CALL	PHEAD
	LD	L,(IX)
	LD	H,(IX+1)
TLINE	LD	C,(IX+9)
	LD	B,(IX+10)
	LD	A,B
	OR	C
	JR	Z,TEND
	DEC	BC
	LD	(IX+9),C
	LD	(IX+10),B
	PUSH	HL
	LD	B,64
	XOR	A
TCH1	ADD	A,(HL)
	INC	HL
	AND	128
	JR	NZ,TCH2
	DJNZ	TCH1
	JR	NOMAR
TCH2	POP	HL
	PUSH	HL
	CALL	MARKS
NOMAR	CALL	SMALL
	POP	HL
	LD	B,64
TCHAR	PUSH	BC
	PUSH	HL
	LD	A,(HL)
	CALL	CHAR
	POP	HL
	POP	BC
	INC	HL
	DJNZ	TCHAR
	PUSH	HL
	CALL	NLINE
	POP	HL
	JR	TLINE
TEND	BIT	0,(IX+6)
	CALL	NZ,EJECT
	JR	TCOPY
CHAR	CP	128
	JP	C,PPRINT
	SUB	193
	JR	C,ERROR
	CP	26
	JR	C,CH1
	SUB	6
CH1	LD	L,A
	LD	H,0
	LD	DE,CHTAB
	ADD	HL,DE
	LD	A,(HL)
	JP	PPRINT
CHTAB	DEFM	'A CDE  U'
	DEFM	'I    NO '
	DEFM	' RSTU E '
	DEFM	'YZ'
	DEFM	'a cde  u'
	DEFM	'i    no '
	DEFM	' rstu e '
	DEFM	'yz'
MARK	SUB	193
	JR	C,ERROR
	CP	26
	JR	C,MA1
	SUB	6
MA1	LD	L,A
	LD	H,0
	LD	DE,MATAB
	ADD	HL,DE
	LD	A,(HL)
	JP	PPRINT
ERROR	LD	A,32
	JP	PPRINT
MATAB	DEFM	'A BBA  C'
	DEFM	'A    BA '
	DEFM	' BBBA B '
	DEFM	'AB'
	DEFM	'D EED  F'
	DEFM	'G    ED '
	DEFM	' EEED E '
	DEFM	'DE'
DEFON	CALL	PTEXT
	DEFB	27,'%'
	DEFB	1,255
	RET
DEFOF	CALL	PTEXT
	DEFB	27,'%'
	DEFB	0,255
	RET
SMALL	CALL	PTEXT
	DEFB	13,27
	DEFB	'J',15
	DEFB	255
	RET
PHEAD	BIT	1,(IX+7)
	CALL	NZ,WHEAD
	BIT	0,(IX+7)
	CALL	NZ,UHEAD
	BIT	2,(IX+7)
	CALL	NZ,PAGEN
	BIT	4,(IX+7)
	CALL	NZ,BEEP
	RET
NLINE	CALL	CRLF
	LD	A,(IX+9)
	OR	(IX+10)
	RET	Z
	DEC	(IX+12)
	RET	NZ
NPAGE	LD	A,(IX+8)
	LD	(IX+12),A
	INC	(IX+17)
	BIT	3,(IX+7)
	CALL	NZ,EJECT
	JP	PHEAD
WHEAD	LD	HL,WRHD
	LD	BC,64
PRSTR	PUSH	HL
	LD	HL,CRLF
	EX	(SP),HL
PRSTG	LD	A,B
	OR	C
	RET	Z
	DEC	BC
	LD	A,(HL)
	INC	HL
	CALL	PPRINT
	JR	PRSTG
WRHD	DEFM	'* Writer'
	DEFM	'/CS Text'
	DEFM	' Editor '
	DEFM	'- ver. 3'
	DEFM	'.0 * Wri'
	DEFM	'tten by '
	DEFM	'SOFTEK &'
	DEFM	' MJSOFT*'
UHEAD	LD	C,(IX+15)
	LD	B,(IX+16)
	LD	L,(IX+13)
	LD	H,(IX+14)
	JR	PRSTR
PAGEN	LD	B,30
PGN1	LD	A,32
	CALL	PPRINT
	DJNZ	PGN1
	LD	A,'-'
	CALL	PPRINT
	LD	A,(IX+17)
	LD	B,255
PGN2	INC	B
	SUB	10
	JR	NC,PGN2
	ADD	A,10
	LD	C,A
	LD	A,B
	ADD	A,'0'
	CALL	PPRINT
	LD	A,C
	ADD	A,'0'
	CALL	PPRINT
	LD	A,'-'
	CALL	PPRINT
	JP	CRLF
PTEXT	POP	HL
	LD	A,(HL)
	INC	HL
	PUSH	HL
	CP	255
	RET	Z
	CALL	PPRINT
	JR	PTEXT
DEFCH	CALL	PTEXT
	DEFB	27,'&',0
	DEFB	'A','G'
;CARKA VELKA
	DEFB	0
	DEFB	0,0,0,0
	DEFB	0,32,64,0
	DEFB	0,0,0
;HACEK VELKY
	DEFB	0
	DEFB	0,0,128
	DEFB	64,32,64,128
	DEFB	0,0,0,0
;KROUZEK VELKY
	DEFB	0
	DEFB	0,0,64
	DEFB	160,160,160,64
	DEFB	0,0,0,0
;CARKA MALA
	DEFB	0
	DEFB	0,0,0,0
	DEFB	0,8,16,32
	DEFB	0,0,0
;HACEK MALY
	DEFB	0
	DEFB	0,0,0,32
	DEFB	16,8,16,32
	DEFB	0,0,0
;KROUZEK MALY
	DEFB	0
	DEFB	0,0,16
	DEFB	40,40,40,16
	DEFB	0,0,0,0
;CARKA NAD I
	DEFB	0
	DEFB	0,0,0,0
	DEFB	0,16,32
	DEFB	0,0,0,0
;KONEC
	DEFB	255
	RET
TE1	DEFM	'TEST TEX'
	DEFM	'TOVEHO E'
	DEFM	'DITORU W'
	DEFM	'RITER / '
	DEFM	'CS, (C) '
	DEFM	'1989 MJS'
	DEFM	'OFT SYST'
	DEFM	'EM SOFT.'

	DEFB	'A'+128,'C'+128
	DEFB	'U'+128,'H'+128
	DEFB	'a'+128,'c'+128
	DEFB	'i'+128,'h'+128
	DEFM	'        '
	DEFM	'        '
	DEFM	'        '
	DEFM	'        '
	DEFM	'        '
	DEFM	'        '
	DEFM	'        '
MODE	CALL	PTEXT
	DEFB	27,'A',8
	DEFB	27,'x',255
	LD	A,(IX+4)
	JP	PPRINT
MARKS	LD	A,(IX+4)
	OR	A
	JR	NZ,LQMRS
	PUSH	HL
	CALL	DEFON
	POP	HL
	LD	B,64
MRN1	LD	A,(HL)
	PUSH	HL
	PUSH	BC
	CALL	MARK
	POP	BC
	POP	HL
	INC	HL
	DJNZ	MRN1
	CALL	DEFOF
CR	LD	A,13
	JP	PPRINT
LQMRS	PUSH	HL
	LD	DE,LQM1
	CALL	LQMRL
	CALL	PTEXT
	DEFB	13
	DEFB	27,'J'
	DEFB	1,255
	POP	HL
	LD	DE,LQM2
	CALL	LQMRL
	JR	CR
LQMAR	SUB	193
	JP	C,ERROR
	CP	26
	JR	C,LM1
	SUB	6
LM1	LD	L,A
	LD	H,0
	LD	BC,MATAB
	ADD	HL,BC
	LD	A,(HL)
	SUB	'A'
	LD	L,A
	LD	H,0
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	B,H
	LD	C,L
	ADD	HL,HL
	ADD	HL,BC
	ADD	HL,DE
	PUSH	HL
	CALL	PTEXT
	DEFB	27,'Z'
	DEFB	24,0
	DEFB	255
	POP	HL
	LD	BC,24
	JP	PRSTG
LQMRL	LD	B,64
LML1	PUSH	HL
	PUSH	BC
	PUSH	DE
	LD	A,(HL)
	CALL	LQMAR
	POP	DE
	POP	BC
	POP	HL
	INC	HL
	DJNZ	LML1
	RET
;NLQ CV1
LQM1	DEFB	0,0,0,0
	DEFB	0,0,0,0
	DEFB	0,0,0,16
	DEFB	0,32,0,64
	DEFB	0,0,0,0
	DEFB	0,0,0,0
;NLQ HV1
	DEFB	0,0,0,0
	DEFB	0,0,64,0
	DEFB	32,0,16,16
	DEFB	0,32,0,64
	DEFB	0,0,0,0
	DEFB	0,0,0,0
;NLQ KV1
	DEFB	0,0,0
	DEFB	0,0,32,16
	DEFB	64,64,64,64
	DEFB	64,64,16,32
	DEFB	0,0,0,0
	DEFB	0,0,0,0,0
;NLQ CM1
	DEFB	0,0,0,0
	DEFB	0,0,0,0
	DEFB	0,0,0,4
	DEFB	0,8,0,16
	DEFB	0,0,0,0
	DEFB	0,0,0,0
;NLQ HM1
	DEFB	0,0,0,0
	DEFB	0,0,16,0
	DEFB	8,0,4,4
	DEFB	0,8,0,16
	DEFB	0,0,0,0
	DEFB	0,0,0,0
;NLQ KM1
	DEFB	0,0,0
	DEFB	0,0,8,4
	DEFB	16,16,16,16
	DEFB	16,16,4,8
	DEFB	0,0,0,0
	DEFB	0,0,0,0,0
;NLQ CI1
	DEFB	0,0,0
	DEFB	0,0,0,0
	DEFB	0,0,0,0
	DEFB	0,8,0,16
	DEFB	0,0,0,0
	DEFB	0,0,0,0,0
;NLQ CV2
LQM2	DEFB	0,0,0,0
	DEFB	0,0,0,0
	DEFB	0,0,0,0
	DEFB	32,0,64,0
	DEFB	0,0,0,0
	DEFB	0,0,0,0
;NLQ HV2
	DEFB	0,0,0,0
	DEFB	0,0,0,64
	DEFB	0,32,0,0
	DEFB	32,0,64,0
	DEFB	0,0,0,0
	DEFB	0,0,0,0
;NLQ KV2
	DEFB	0,0,0
	DEFB	0,0,32,64
	DEFB	16,16,16,16
	DEFB	16,16,64,32
	DEFB	0,0,0,0
	DEFB	0,0,0,0,0
;NLQ CM2
	DEFB	0,0,0,0
	DEFB	0,0,0,0
	DEFB	0,0,0,0
	DEFB	8,0,16,0
	DEFB	0,0,0,0
	DEFB	0,0,0,0
;NLQ HM2
	DEFB	0,0,0,0
	DEFB	0,0,0,16
	DEFB	0,8,0,0
	DEFB	8,0,16,0
	DEFB	0,0,0,0
	DEFB	0,0,0,0
;NLQ KM2
	DEFB	0,0,0
	DEFB	0,0,8,16
	DEFB	4,4,4,4
	DEFB	4,4,16,8
	DEFB	0,0,0,0
	DEFB	0,0,0,0,0
;NLQ CI2
	DEFB	0,0,0
	DEFB	0,0,0,0
	DEFB	0,0,0,0
	DEFB	8,0,16,0
	DEFB	0,0,0,0
	DEFB	0,0,0,0,0
BASIC	RST	8
	DEFB	255
BEEP	PUSH	BC
	PUSH	DE
	PUSH	HL
	PUSH	IX
	LD	B,0
	LD	DE,1
	LD	HL,1024
BE1	PUSH	BC
	PUSH	DE
	PUSH	HL
	CALL	03B5H
	POP	HL
	POP	DE
	POP	BC
	DEC	HL
	DJNZ	BE1
	POP	IX
	POP	HL
	POP	DE
	POP	BC
	RET
EJECT	LD	A,12
	JP	PPRINT
*D+
*L+
	NOP
*L-


;DATA ZONES

	ORG	65476
TVARS	DEFW	TE1
	DEFW	1
	DEFB	0
	DEFB	1
	DEFB	0
	DEFB	0
	DEFB	64
	DEFW	0
	DEFB	0
	DEFB	0
	DEFW	0
	DEFW	0
	DEFB	0

	ORG	65506
VARS	DEFW	0,0
	DEFW	1,1
	DEFW	0,0
	DEFW	0
	DEFW	0
	DEFW	20
DENS	DEFB	0
INTER	DEFB	1
RAM	DEFB	0
