; Filled Circle version 1.0
;(c) 1991 MJSoft System Software
; Martin Mares

	org	60000

	call	1c79h
	call	2314h
	push	af
	call	2314h
	ld	c,a
	pop	af
	ld	b,a
	push	bc
	call	1c81h
	call	2314h
	pop	bc
	call	fc

rt	ld	hl,(23613)
	dec	hl
	dec	hl
	ld	sp,hl
	ei
	ret

fc	ld	ix,bitmap
	ld	de,3
	ld	l,a
	ld	h,0
	add	hl,hl
	ex	de,hl
	and	a
	sbc	hl,de
	ex	de,hl
	ld	l,0
	ld	h,a
	ex	af,af'
fc1	ld	a,l
	cp	h
	jr	nc,fcend1
	call	draca
	push	hl
	push	bc
	ld	c,h
	ld	h,0
	bit	7,d
	jr	z,pge0
	ld	bc,6
	jr	pge01
pge0	ld	b,0
	and	a
	sbc	hl,bc
	ld	c,10
pge01	add	hl,hl
	add	hl,hl
	add	hl,bc
	add	hl,de
	ex	de,hl
	ld	a,c
	pop	bc
	pop	hl
	cp	10
	jr	nz,pge02
	dec	h
pge02	inc	l
	jr	fc1

fcend1	call	dracb
	ret

draca	ex	af,af'
	cp	h
	jr	z,draca1
	ld	a,h
	ex	af,af'
	push	bc
	ld	a,c
	sub	l
	ld	c,a
	push	bc
	ld	a,b
	sub	h
	ld	b,a
	ld	a,l
	add	a,a
	call	draw
	pop	bc
	ld	a,b
	add	a,h
	ld	b,a
	ld	a,l
	add	a,a
	call	draw
	pop	bc
	jr	dracb

draca1	ex	af,af'
dracb	push	bc
	push	hl
	ld	a,h
	ld	h,l
	ld	l,a
	ld	a,c
	sub	l
	ld	c,a
	push	bc
	ld	a,b
	sub	h
	ld	b,a
	ld	a,l
	add	a,a
	call	draw
	pop	bc
	ld	a,b
	add	a,h
	ld	b,a
	ld	a,l
	add	a,a
	call	draw
	pop	hl
	pop	bc
	ret

draw	cp	8
	jr	c,qdraw
	exx
	ld	d,a
	exx
	push	hl
	call	22aah
	ex	(sp),hl
	exx
	pop	hl
	ld	e,a
	add	a,8
	ld	(draw1+2),a
draw1	ld	a,(ix)
	or	(hl)
	ld	(hl),a
	inc	l
	ld	a,d
	sub	8
	add	a,e
draw2	sub	8
	jr	c,draw3
	ld	(hl),255
	inc	l
	jr	draw2
draw3	add	a,24
	ld	(draw4+2),a
draw4	ld	a,(ix)
	or	(hl)
	ld	(hl),a
	exx
	ret

qdraw	or	a
	ret	z
	push	hl
qdraw1	push	af
	push	bc
	call	plot
	pop	bc
	inc	c
	pop	af
	dec	a
	jr	nz,qdraw1
	pop	hl
	ret

plot	call	22aah
	ld	(plot1+2),a
plot1	ld	a,(ix)
	or	(hl)
	ld	(hl),a
	ret

bitmap	db	128,64,32,16
	db	8,4,2,1

	db	0ffh,7fh,3fh,1fh
	db	0fh,7,3,1

	db	0,80h,0c0h,0e0h,0f0h
	db	0f8h,0fch,0feh

	org	61000

cls	di
	ld	sp,22528
	ld	b,192
	ld	hl,0
cls1	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	djnz	cls1
	jp	rt
